unit Test;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ProGrids, ProBase, Menus, StdCtrls;

type
  TForm1 = class(TForm)
    ProGridStyler1: TProGridStyler;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Print1: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    PrintSetup1: TMenuItem;
    N2: TMenuItem;
    PrintDialog: TPrintDialog;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    Edit2: TMenuItem;
    ProGrid1: TProGrid;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    procedure Exit1Click(Sender: TObject);
    procedure Edit1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ProGrid1ValidNumber(ACol, ARow: Longint; var AMin, AMax,
      AInc: Double);
  private
    { Private declarations }
    FFileName : String;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation uses ProDsg;

{$R *.DFM}

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Edit1Click(Sender: TObject);
var PD: TProDesigner;
begin
    CompLib := True;
    PD := TProDesigner.Create(Application);
    PD.FTransfer := ProGrid1;
    PD.AcceptEditGrid(PD.FTransfer, PD.WorkGrid);
    PD.UpdateFonts;
    PD.UpdateClipboard;
    PD.ShowModal;
    PD.Free;
    CompLib := False;
end;

procedure TForm1.Print1Click(Sender: TObject);
begin
  if PrintDialog.Execute then ProGrid1.Print(ptAll);
end;

procedure TForm1.PrintSetup1Click(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;

procedure TForm1.Save1Click(Sender: TObject);
var F: TFileStream;
begin
  F := TFileStream.Create(FFileName, fmCreate);
  F.WriteComponent(ProGrid1);
  F.Free;
end;

procedure TForm1.Saveas1Click(Sender: TObject);
begin
  SaveDialog1.FileName := FFileName;
  if SaveDialog1.Execute then
  begin
    FFileName := SaveDialog1.FileName;
    Save1Click(Self);
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var F: TFileStream;
    T: TProGrid;
begin
  if OpenDialog1.Execute then
  try
    FFileName := OpenDialog1.FileName;
    F := TFileStream.Create(FFileName, fmOpenRead);
    T := TProGrid(F.ReadComponent(nil));
    F.Free;
    ProGrid1.Assign(T);
    ProGrid1.GridStyler := ProGridStyler1;
    T.Free;
  except
    Application.MessageBox('Cannot read this file!', 'ProGrid Demo', MB_OK);
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FFileName := 'progrid.pro';
  RegisterClass(TProGrid);
end;

procedure TForm1.ProGrid1ValidNumber(ACol, ARow: Longint; var AMin, AMax,
  AInc: Double);
begin
  if (ACol = 1) and (ARow = 4) then
  begin
    AMin := -5;
    AMax := 5;
  end;
end;

end.
